/*
 * NE PAS EDITER CE FICHIER - il est gnr par Glade.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "gtailsig.h"
#include "gtailsrc.h"
#include "support.h"

GtkWidget*
create_gtail (void)
{
  GtkWidget *gtail;
  GtkWidget *vbox1;
  GtkWidget *menubar2;
  GtkWidget *FileMenu;
  GtkWidget *FileMenu_menu;
  GtkAccelGroup *FileMenu_menu_accels;
  GtkWidget *OpenMenuItem;
  GtkWidget *CmdMenuItem;
  GtkWidget *s_parateur1;
  GtkWidget *QuitMenuItem;
  GtkWidget *HelpMenu;
  GtkWidget *HelpMenu_menu;
  GtkAccelGroup *HelpMenu_menu_accels;
  GtkWidget *AboutMenuItem;
  GtkWidget *ButtonBox;
  GtkWidget *ButtonOpenFile;
  GtkWidget *pixmap1;
  GtkWidget *ButtonExec;
  GtkWidget *pixmap2;
  GtkWidget *ButtonConfig;
  GtkWidget *pixmap3;
  GtkWidget *ButtonHelp;
  GtkWidget *pixmap4;
  GtkWidget *ButtonQuit;
  GtkWidget *pixmap5;
  GtkWidget *NoteBook;
  GtkWidget *StatusBar;
  GtkAccelGroup *accel_group;
  GtkTooltips *tooltips;

  tooltips = gtk_tooltips_new ();

  accel_group = gtk_accel_group_new ();

  gtail = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_name (gtail, "gtail");
  gtk_object_set_data (GTK_OBJECT (gtail), "gtail", gtail);
  gtk_widget_set_usize (gtail, 300, 200);
  gtk_window_set_title (GTK_WINDOW (gtail), _("gtail"));
  gtk_window_set_policy (GTK_WINDOW (gtail), TRUE, TRUE, FALSE);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox1, "vbox1");
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (gtail), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (gtail), vbox1);

  menubar2 = gtk_menu_bar_new ();
  gtk_widget_set_name (menubar2, "menubar2");
  gtk_widget_ref (menubar2);
  gtk_object_set_data_full (GTK_OBJECT (gtail), "menubar2", menubar2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menubar2);
  gtk_box_pack_start (GTK_BOX (vbox1), menubar2, FALSE, TRUE, 0);

  FileMenu = gtk_menu_item_new_with_label (_("File"));
  gtk_widget_set_name (FileMenu, "FileMenu");
  gtk_widget_ref (FileMenu);
  gtk_object_set_data_full (GTK_OBJECT (gtail), "FileMenu", FileMenu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (FileMenu);
  gtk_container_add (GTK_CONTAINER (menubar2), FileMenu);

  FileMenu_menu = gtk_menu_new ();
  gtk_widget_set_name (FileMenu_menu, "FileMenu_menu");
  gtk_widget_ref (FileMenu_menu);
  gtk_object_set_data_full (GTK_OBJECT (gtail), "FileMenu_menu", FileMenu_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (FileMenu), FileMenu_menu);
  FileMenu_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (FileMenu_menu));

  OpenMenuItem = gtk_menu_item_new_with_label (_("Open file"));
  gtk_widget_set_name (OpenMenuItem, "OpenMenuItem");
  gtk_widget_ref (OpenMenuItem);
  gtk_object_set_data_full (GTK_OBJECT (gtail), "OpenMenuItem", OpenMenuItem,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (OpenMenuItem);
  gtk_container_add (GTK_CONTAINER (FileMenu_menu), OpenMenuItem);
  gtk_widget_add_accelerator (OpenMenuItem, "activate", accel_group,
                              GDK_F, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  CmdMenuItem = gtk_menu_item_new_with_label (_("Open command"));
  gtk_widget_set_name (CmdMenuItem, "CmdMenuItem");
  gtk_widget_ref (CmdMenuItem);
  gtk_object_set_data_full (GTK_OBJECT (gtail), "CmdMenuItem", CmdMenuItem,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CmdMenuItem);
  gtk_container_add (GTK_CONTAINER (FileMenu_menu), CmdMenuItem);
  gtk_widget_add_accelerator (CmdMenuItem, "activate", accel_group,
                              GDK_C, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  s_parateur1 = gtk_menu_item_new ();
  gtk_widget_set_name (s_parateur1, "s_parateur1");
  gtk_widget_ref (s_parateur1);
  gtk_object_set_data_full (GTK_OBJECT (gtail), "s_parateur1", s_parateur1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (s_parateur1);
  gtk_container_add (GTK_CONTAINER (FileMenu_menu), s_parateur1);
  gtk_widget_set_sensitive (s_parateur1, FALSE);

  QuitMenuItem = gtk_menu_item_new_with_label (_("Quit"));
  gtk_widget_set_name (QuitMenuItem, "QuitMenuItem");
  gtk_widget_ref (QuitMenuItem);
  gtk_object_set_data_full (GTK_OBJECT (gtail), "QuitMenuItem", QuitMenuItem,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (QuitMenuItem);
  gtk_container_add (GTK_CONTAINER (FileMenu_menu), QuitMenuItem);
  gtk_widget_add_accelerator (QuitMenuItem, "activate", accel_group,
                              GDK_X, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  HelpMenu = gtk_menu_item_new_with_label (_("Help"));
  gtk_widget_set_name (HelpMenu, "HelpMenu");
  gtk_widget_ref (HelpMenu);
  gtk_object_set_data_full (GTK_OBJECT (gtail), "HelpMenu", HelpMenu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (HelpMenu);
  gtk_container_add (GTK_CONTAINER (menubar2), HelpMenu);
  gtk_menu_item_right_justify (GTK_MENU_ITEM (HelpMenu));

  HelpMenu_menu = gtk_menu_new ();
  gtk_widget_set_name (HelpMenu_menu, "HelpMenu_menu");
  gtk_widget_ref (HelpMenu_menu);
  gtk_object_set_data_full (GTK_OBJECT (gtail), "HelpMenu_menu", HelpMenu_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (HelpMenu), HelpMenu_menu);
  HelpMenu_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (HelpMenu_menu));

  AboutMenuItem = gtk_menu_item_new_with_label (_("A propos"));
  gtk_widget_set_name (AboutMenuItem, "AboutMenuItem");
  gtk_widget_ref (AboutMenuItem);
  gtk_object_set_data_full (GTK_OBJECT (gtail), "AboutMenuItem", AboutMenuItem,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (AboutMenuItem);
  gtk_container_add (GTK_CONTAINER (HelpMenu_menu), AboutMenuItem);

  ButtonBox = gtk_hbutton_box_new ();
  gtk_widget_set_name (ButtonBox, "ButtonBox");
  gtk_widget_ref (ButtonBox);
  gtk_object_set_data_full (GTK_OBJECT (gtail), "ButtonBox", ButtonBox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ButtonBox);
  gtk_box_pack_start (GTK_BOX (vbox1), ButtonBox, FALSE, FALSE, 0);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (ButtonBox), GTK_BUTTONBOX_START);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (ButtonBox), 0);
  gtk_button_box_set_child_size (GTK_BUTTON_BOX (ButtonBox), 0, 18);
  gtk_button_box_set_child_ipadding (GTK_BUTTON_BOX (ButtonBox), 0, 0);

  ButtonOpenFile = gtk_button_new ();
  gtk_widget_set_name (ButtonOpenFile, "ButtonOpenFile");
  gtk_widget_ref (ButtonOpenFile);
  gtk_object_set_data_full (GTK_OBJECT (gtail), "ButtonOpenFile", ButtonOpenFile,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ButtonOpenFile);
  gtk_container_add (GTK_CONTAINER (ButtonBox), ButtonOpenFile);
  gtk_widget_set_usize (ButtonOpenFile, 17, 17);
  GTK_WIDGET_SET_FLAGS (ButtonOpenFile, GTK_CAN_DEFAULT);
  gtk_tooltips_set_tip (tooltips, ButtonOpenFile, _("Open File..."), NULL);
  gtk_widget_add_accelerator (ButtonOpenFile, "clicked", accel_group,
                              GDK_f, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  pixmap1 = create_pixmap (gtail, "file.xpm");
  gtk_widget_set_name (pixmap1, "pixmap1");
  gtk_widget_ref (pixmap1);
  gtk_object_set_data_full (GTK_OBJECT (gtail), "pixmap1", pixmap1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pixmap1);
  gtk_container_add (GTK_CONTAINER (ButtonOpenFile), pixmap1);

  ButtonExec = gtk_button_new ();
  gtk_widget_set_name (ButtonExec, "ButtonExec");
  gtk_widget_ref (ButtonExec);
  gtk_object_set_data_full (GTK_OBJECT (gtail), "ButtonExec", ButtonExec,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ButtonExec);
  gtk_container_add (GTK_CONTAINER (ButtonBox), ButtonExec);
  GTK_WIDGET_SET_FLAGS (ButtonExec, GTK_CAN_DEFAULT);
  gtk_widget_add_accelerator (ButtonExec, "clicked", accel_group,
                              GDK_c, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  pixmap2 = create_pixmap (gtail, "exec.xpm");
  gtk_widget_set_name (pixmap2, "pixmap2");
  gtk_widget_ref (pixmap2);
  gtk_object_set_data_full (GTK_OBJECT (gtail), "pixmap2", pixmap2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pixmap2);
  gtk_container_add (GTK_CONTAINER (ButtonExec), pixmap2);

  ButtonConfig = gtk_button_new ();
  gtk_widget_set_name (ButtonConfig, "ButtonConfig");
  gtk_widget_ref (ButtonConfig);
  gtk_object_set_data_full (GTK_OBJECT (gtail), "ButtonConfig", ButtonConfig,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ButtonConfig);
  gtk_container_add (GTK_CONTAINER (ButtonBox), ButtonConfig);
  GTK_WIDGET_SET_FLAGS (ButtonConfig, GTK_CAN_DEFAULT);

  pixmap3 = create_pixmap (gtail, "config.xpm");
  gtk_widget_set_name (pixmap3, "pixmap3");
  gtk_widget_ref (pixmap3);
  gtk_object_set_data_full (GTK_OBJECT (gtail), "pixmap3", pixmap3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pixmap3);
  gtk_container_add (GTK_CONTAINER (ButtonConfig), pixmap3);

  ButtonHelp = gtk_button_new ();
  gtk_widget_set_name (ButtonHelp, "ButtonHelp");
  gtk_widget_ref (ButtonHelp);
  gtk_object_set_data_full (GTK_OBJECT (gtail), "ButtonHelp", ButtonHelp,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ButtonHelp);
  gtk_container_add (GTK_CONTAINER (ButtonBox), ButtonHelp);
  GTK_WIDGET_SET_FLAGS (ButtonHelp, GTK_CAN_DEFAULT);

  pixmap4 = create_pixmap (gtail, "book.xpm");
  gtk_widget_set_name (pixmap4, "pixmap4");
  gtk_widget_ref (pixmap4);
  gtk_object_set_data_full (GTK_OBJECT (gtail), "pixmap4", pixmap4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pixmap4);
  gtk_container_add (GTK_CONTAINER (ButtonHelp), pixmap4);

  ButtonQuit = gtk_button_new ();
  gtk_widget_set_name (ButtonQuit, "ButtonQuit");
  gtk_widget_ref (ButtonQuit);
  gtk_object_set_data_full (GTK_OBJECT (gtail), "ButtonQuit", ButtonQuit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ButtonQuit);
  gtk_container_add (GTK_CONTAINER (ButtonBox), ButtonQuit);
  GTK_WIDGET_SET_FLAGS (ButtonQuit, GTK_CAN_DEFAULT);
  gtk_widget_add_accelerator (ButtonQuit, "clicked", accel_group,
                              GDK_x, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  pixmap5 = create_pixmap (gtail, "diropen2.xpm");
  gtk_widget_set_name (pixmap5, "pixmap5");
  gtk_widget_ref (pixmap5);
  gtk_object_set_data_full (GTK_OBJECT (gtail), "pixmap5", pixmap5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pixmap5);
  gtk_container_add (GTK_CONTAINER (ButtonQuit), pixmap5);

  NoteBook = gtk_notebook_new ();
  gtk_widget_set_name (NoteBook, "NoteBook");
  gtk_widget_ref (NoteBook);
  gtk_object_set_data_full (GTK_OBJECT (gtail), "NoteBook", NoteBook,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (NoteBook);
  gtk_box_pack_start (GTK_BOX (vbox1), NoteBook, TRUE, TRUE, 0);
  gtk_notebook_set_scrollable (GTK_NOTEBOOK (NoteBook), TRUE);

  StatusBar = gtk_statusbar_new ();
  gtk_widget_set_name (StatusBar, "StatusBar");
  gtk_widget_ref (StatusBar);
  gtk_object_set_data_full (GTK_OBJECT (gtail), "StatusBar", StatusBar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (StatusBar);
  gtk_box_pack_start (GTK_BOX (vbox1), StatusBar, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (gtail), "destroy_event",
                      GTK_SIGNAL_FUNC (on_gtail_destroy_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (gtail), "delete_event",
                      GTK_SIGNAL_FUNC (on_gtail_delete_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (FileMenu), "activate",
                      GTK_SIGNAL_FUNC (on_FileMenu_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (OpenMenuItem), "activate",
                      GTK_SIGNAL_FUNC (on_OpenMenuItem_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (CmdMenuItem), "activate",
                      GTK_SIGNAL_FUNC (on_CmdMenuItem_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (QuitMenuItem), "activate",
                      GTK_SIGNAL_FUNC (on_QuitMenuItem_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (HelpMenu), "activate",
                      GTK_SIGNAL_FUNC (on_HelpMenu_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (AboutMenuItem), "activate",
                      GTK_SIGNAL_FUNC (on_AboutMenuItem_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ButtonOpenFile), "clicked",
                      GTK_SIGNAL_FUNC (on_ButtonOpenFile_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ButtonExec), "clicked",
                      GTK_SIGNAL_FUNC (on_ButtonExec_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ButtonQuit), "clicked",
                      GTK_SIGNAL_FUNC (on_ButtonQuit_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (NoteBook), "switch_page",
                      GTK_SIGNAL_FUNC (on_NoteBook_switch_page),
                      NULL);
  gtk_signal_connect_after (GTK_OBJECT (NoteBook), "button_release_event",
                            GTK_SIGNAL_FUNC (remove_page),
                            NULL);

  gtk_object_set_data (GTK_OBJECT (gtail), "tooltips", tooltips);

  gtk_window_add_accel_group (GTK_WINDOW (gtail), accel_group);

  return gtail;
}

GtkWidget*
create_FileSelector (void)
{
  GtkWidget *FileSelector;
  GtkWidget *AddButton;
  GtkWidget *CloseButton;

  FileSelector = gtk_file_selection_new (_("Select a file"));
  gtk_widget_set_name (FileSelector, "FileSelector");
  gtk_object_set_data (GTK_OBJECT (FileSelector), "FileSelector", FileSelector);
  gtk_container_set_border_width (GTK_CONTAINER (FileSelector), 10);
  gtk_file_selection_hide_fileop_buttons (GTK_FILE_SELECTION (FileSelector));

  AddButton = GTK_FILE_SELECTION (FileSelector)->ok_button;
  gtk_widget_set_name (AddButton, "AddButton");
  gtk_object_set_data (GTK_OBJECT (FileSelector), "AddButton", AddButton);
  gtk_widget_show (AddButton);
  GTK_WIDGET_SET_FLAGS (AddButton, GTK_CAN_DEFAULT);

  CloseButton = GTK_FILE_SELECTION (FileSelector)->cancel_button;
  gtk_widget_set_name (CloseButton, "CloseButton");
  gtk_object_set_data (GTK_OBJECT (FileSelector), "CloseButton", CloseButton);
  gtk_widget_show (CloseButton);
  GTK_WIDGET_SET_FLAGS (CloseButton, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (AddButton), "clicked",
                      GTK_SIGNAL_FUNC (on_AddButton_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (CloseButton), "clicked",
                      GTK_SIGNAL_FUNC (on_CloseButton_clicked),
                      NULL);

  return FileSelector;
}

GtkWidget*
create_CmdWindow (void)
{
  GtkWidget *CmdWindow;
  GtkWidget *vbox2;
  GtkWidget *label1;
  GtkWidget *CmdName;
  GtkWidget *hbox1;
  GtkWidget *CheckButtonRepeat;
  GtkWidget *ScaleRepeat;
  GtkWidget *hbuttonbox1;
  GtkWidget *CmdChoosed;
  GtkWidget *CmdAbort;
  GtkAccelGroup *accel_group;

  accel_group = gtk_accel_group_new ();

  CmdWindow = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_widget_set_name (CmdWindow, "CmdWindow");
  gtk_object_set_data (GTK_OBJECT (CmdWindow), "CmdWindow", CmdWindow);
  gtk_window_set_title (GTK_WINDOW (CmdWindow), _("Select a command"));
  gtk_window_set_position (GTK_WINDOW (CmdWindow), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (CmdWindow), TRUE);

  vbox2 = gtk_vbox_new (FALSE, 9);
  gtk_widget_set_name (vbox2, "vbox2");
  gtk_widget_ref (vbox2);
  gtk_object_set_data_full (GTK_OBJECT (CmdWindow), "vbox2", vbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox2);
  gtk_container_add (GTK_CONTAINER (CmdWindow), vbox2);
  gtk_container_set_border_width (GTK_CONTAINER (vbox2), 10);

  label1 = gtk_label_new (_("Launch command :"));
  gtk_widget_set_name (label1, "label1");
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (CmdWindow), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (vbox2), label1, TRUE, FALSE, 3);
  gtk_label_set_justify (GTK_LABEL (label1), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label1), TRUE);
  gtk_misc_set_padding (GTK_MISC (label1), 10, 0);

  CmdName = gtk_entry_new ();
  gtk_widget_set_name (CmdName, "CmdName");
  gtk_widget_ref (CmdName);
  gtk_object_set_data_full (GTK_OBJECT (CmdWindow), "CmdName", CmdName,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CmdName);
  gtk_box_pack_start (GTK_BOX (vbox2), CmdName, TRUE, FALSE, 0);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox1, "hbox1");
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (CmdWindow), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox2), hbox1, TRUE, TRUE, 0);

  CheckButtonRepeat = gtk_check_button_new_with_label (_("Repeat (second)"));
  gtk_widget_set_name (CheckButtonRepeat, "CheckButtonRepeat");
  gtk_widget_ref (CheckButtonRepeat);
  gtk_object_set_data_full (GTK_OBJECT (CmdWindow), "CheckButtonRepeat", CheckButtonRepeat,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CheckButtonRepeat);
  gtk_box_pack_start (GTK_BOX (hbox1), CheckButtonRepeat, FALSE, TRUE, 0);

  ScaleRepeat = gtk_hscale_new (GTK_ADJUSTMENT (gtk_adjustment_new (1, 1, 86400, 1, 60, 0)));
  gtk_widget_set_name (ScaleRepeat, "ScaleRepeat");
  gtk_widget_ref (ScaleRepeat);
  gtk_object_set_data_full (GTK_OBJECT (CmdWindow), "ScaleRepeat", ScaleRepeat,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ScaleRepeat);
  gtk_box_pack_start (GTK_BOX (hbox1), ScaleRepeat, FALSE, FALSE, 0);
  gtk_widget_set_sensitive (ScaleRepeat, FALSE);
  GTK_WIDGET_UNSET_FLAGS (ScaleRepeat, GTK_CAN_FOCUS);
  gtk_scale_set_digits (GTK_SCALE (ScaleRepeat), 0);

  hbuttonbox1 = gtk_hbutton_box_new ();
  gtk_widget_set_name (hbuttonbox1, "hbuttonbox1");
  gtk_widget_ref (hbuttonbox1);
  gtk_object_set_data_full (GTK_OBJECT (CmdWindow), "hbuttonbox1", hbuttonbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox1);
  gtk_box_pack_start (GTK_BOX (vbox2), hbuttonbox1, TRUE, FALSE, 0);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox1), GTK_BUTTONBOX_SPREAD);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (hbuttonbox1), 0);
  gtk_button_box_set_child_size (GTK_BUTTON_BOX (hbuttonbox1), 0, 27);

  CmdChoosed = gtk_button_new_with_label (_("OK"));
  gtk_widget_set_name (CmdChoosed, "CmdChoosed");
  gtk_widget_ref (CmdChoosed);
  gtk_object_set_data_full (GTK_OBJECT (CmdWindow), "CmdChoosed", CmdChoosed,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CmdChoosed);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), CmdChoosed);
  GTK_WIDGET_SET_FLAGS (CmdChoosed, GTK_CAN_DEFAULT);
  gtk_widget_add_accelerator (CmdChoosed, "clicked", accel_group,
                              GDK_Return, 0,
                              GTK_ACCEL_VISIBLE);

  CmdAbort = gtk_button_new_with_label (_("Cancel"));
  gtk_widget_set_name (CmdAbort, "CmdAbort");
  gtk_widget_ref (CmdAbort);
  gtk_object_set_data_full (GTK_OBJECT (CmdWindow), "CmdAbort", CmdAbort,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CmdAbort);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), CmdAbort);
  GTK_WIDGET_SET_FLAGS (CmdAbort, GTK_CAN_DEFAULT);
  gtk_widget_add_accelerator (CmdAbort, "clicked", accel_group,
                              GDK_Escape, 0,
                              GTK_ACCEL_VISIBLE);

  gtk_signal_connect (GTK_OBJECT (CheckButtonRepeat), "toggled",
                      GTK_SIGNAL_FUNC (on_CheckButtonRepeat_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (CmdChoosed), "clicked",
                      GTK_SIGNAL_FUNC (on_cmd_choosed_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (CmdAbort), "clicked",
                      GTK_SIGNAL_FUNC (on_cmd_abort_clicked),
                      NULL);

  gtk_widget_grab_focus (CmdName);
  gtk_widget_grab_default (CmdChoosed);
  gtk_window_add_accel_group (GTK_WINDOW (CmdWindow), accel_group);

  return CmdWindow;
}

